#pragma once
/***********************************************
**	Matrisebiblioteket mitt
**	Har 3 typer elementer, SparseMatrix, Array og Identitetsmatrise
**	Matrix3x3 og Node er kun klasser brukt av disse
**
**	Sttter stort sett kun de operasjonene som kreves av partikkelsystemet
***********************************************/
#include <stdio.h>
#define NULL 0
#define SIGMA1 0.0000001
void error(char *feilmelding);
#define Equals(a, b) (a-SIGMA1 <= b && b <= a+SIGMA1)

class Matrix3x3
{
public:
	Matrix3x3(){}

	void kopier(Matrix3x3 &m)
	{
		for(int i = 0; i < 3; i++)
		{
			for(int j = 0; j<  3; j++)
			{
				d[i][j] = m.d[i][j];
			}
		}
	}
	double determinant(double d0, double d1, double d2, double d3)
	{
		return d0 * d3 - d1 * d2;
	}
	double determinant(double d0, double d1, double d2, double d3, double d4, double d5, double d6, double d7, double d8)
	{
		return d0 * determinant(d4, d5, d7, d8) - d1 * determinant(d3, d5, d6, d8) + d2 * determinant(d3, d4, d6, d7);
	}
	Matrix3x3 inverse()
	{
		Matrix3x3 retur;

		Matrix3x3 I; I.NullStill(); I.d[0][0] = I.d[1][1] = I.d[2][2] = 1;
		for(int i = 0; i < 3; i++)
		{
			for(int j = 0; j <3; j++)
			{
				retur.d[i][j] = d[i][j];
			}
		}
		for(int i = 0; i < 3; i++)
		{
			if(Equals(d[i][i], 0))
			{
				for(int j = 0; j < 3; j++)
				{
					if(!Equals(d[j][i], 0))
					{
						for(int k = 0; k < 3; k++)
						{
							retur.d[i][k] += retur.d[j][k];
							I.d[i][k] += I.d[j][k];
						}
					}
				}
			}
		}
		// Skal s nulle alle under diagonal
		for(int i = 0; i < 3; i++)
		{
			if(Equals(d[i][i], 0))
			{
				printf("Det ble en 0\n");
				getchar();
			}
			for(int j = i+1; j < 3; j++)
			{
				double faktor = retur.d[j][i] / retur.d[i][i];
				for(int k = 0; k < 3; k++)
				{
					retur.d[j][k] -= faktor * retur.d[i][k];
					I.d[j][k] -= faktor * I.d[i][k];
				}
			}
		}
		// Skal s nulle alle over diagonalen
		for(int i = 2; i >= 0; i--)
		{
			if(Equals(d[i][i], 0))
			{
				printf("Det har blitt en 0 i 2.\n");
				getchar();
			}
			for(int j = i-1; j >= 0; j--)
			{
				double faktor = retur.d[j][i] / retur.d[i][i];
				for(int k = j; k < 3; k++)
				{
					retur.d[j][k] -= faktor * retur.d[i][k];
					I.d[j][k] -= faktor * I.d[i][k];
				}
			}
		}
		for(int i = 0; i < 3; i++)
		{
			for(int j = 0; j < 3; j++)
			{
				I.d[i][j] /= retur.d[i][i];
			}
		}
		
		
		

		
		return I;
	}
	void NullStill()
	{
		for(int i = 0; i < 3; i++)
		{
			for(int j = 0; j<  3; j++)
			{
				d[i][j] = 0;
			}
		}
	}
	inline const Matrix3x3 &operator-=(const Matrix3x3 &m)
	{
		for(int i = 0; i < 3; i++)
		{
			for(int j = 0; j < 3; j++)
			{
				d[i][j] -= m.d[i][j];
			}
		}
		return *this;
	}
	inline const Matrix3x3 &operator+=(const Matrix3x3 &m)
	{
		for(int i = 0; i < 3; i++)
		{
			for(int j = 0; j < 3; j++)
			{
				d[i][j] += m.d[i][j];
			}
		}
		return *this;
	}
		
	inline Matrix3x3 operator-(const Matrix3x3 &m)
	{
		Matrix3x3 retur;
		for(int i = 0; i < 3; i++)
		{
			for(int j = 0; j < 3; j++)
			{
				retur.d[i][j] = d[i][j] - m.d[i][j];
			}
		}
		return retur;
	}

	inline Matrix3x3 operator+(const Matrix3x3 &m)
	{
		Matrix3x3 retur;
		for(int i = 0; i < 3; i++)
		{
			for(int j = 0; j < 3; j++)
			{
				retur.d[i][j] = d[i][j] + m.d[i][j];
			}
		}
		return retur;
	}

	inline Matrix3x3 operator*(double da)
	{
		Matrix3x3 retur;
		for(int i = 0; i < 3; i++)
		{
			for(int j = 0; j < 3; j++)
			{
				retur.d[i][j] = d[i][j] * da;
				
			}
		}
		return retur;
	}
	inline const Matrix3x3 &operator+(double da)
	{
		for(int i = 0; i < 3; i++)
		{
			for(int j = 0; j < 3; j++)
			{
				d[i][j] *= da;
			}
		}
		return *this;
	}
	inline Matrix3x3 operator*(const Matrix3x3 &m)
	{
		Matrix3x3 retur;
		for(int i = 0; i < 3; i++)
		{
			for(int j = 0; j < 3; j++)
			{
				retur.d[i][j] = 0;
				for(int k = 0; k < 3; k++)
				{
					retur.d[i][j] += d[i][k] * m.d[k][j];
				}
			}
		}
		return retur;
	}
	double d[3][3];
};
class Node
{
private:
	Node(int i, int j, Matrix3x3 d, Node *n = NULL) :
		r(i), c(j), data(d), neste(n)
		{
		}
public:
	
	~Node()
	{
		neste = 0;
	}
	Matrix3x3 data;
	Node *neste;
	int r, c;
	static bool rekursivSlett;
	static inline Node *GetNode(int i, int j, Matrix3x3 *d, Node *n = NULL)
	{
		if(nNoder == 0) 
		{
			if(d == NULL) 
			{
				Matrix3x3 temp; temp.NullStill();
				return new Node(i, j, temp, n);
			}
			else
			{
				return new Node(i, j, *d, n);
			}
		}
		
		nNoder--;
		noder[nNoder]->r = i; noder[nNoder]->c = j; noder[nNoder]->neste = n;

		if(d != 0) noder[nNoder]->data.kopier(*d); 
		else noder[nNoder]->data.NullStill();
		return noder[nNoder];

	}
	static inline void returnNode(Node *old)
	{
		if(nNoder == MAX)
		{
			utvid();
			//delete old; 
			// old = 0;
			//return;
		}
		noder[nNoder++] = old;
	}
	static inline void utvid()
	{
		Node **ny = new Node*[MAX*2];

		for(int i = 0; i < MAX; i++)
		{
			ny[i] = noder[i];
		}
		delete[] noder;
		noder = ny;
		MAX *= 2;
	}
	

	static Node** noder;
	static int nNoder;
	static int MAX;

	
	
};
class SMatrise
{
public:
	static double UGYLDIG;
	SMatrise() : r(0), c(0), row(0)
	{}
	SMatrise(int h, int b) : r(h), c(b) 
	{
		row = new Node*[r];
		for(int i = 0; i < r; i++) row[i] = 0;
	}
	~SMatrise()
	{
		//printf("Sletter smatrise\n");
		//return;
		if(row != NULL)
		{
			//Node::rekursivSlett = true;
			for(int i = 0; i < r; i++)
			{
				Node *p = row[i];
				while(p != NULL)
				{
					Node *neste = p->neste;
					Node::returnNode(p);
					p = neste;
					
				}
			}
			//Node::rekursivSlett = false;
			delete[] row;
			
			row = 0;
		}
	}
	Node **row;
	

	int r, c;

	// Denne metoden fungerer under prinsippet at om en bruker funksjonen (i, j), s velger en et element som skal vre i den sparse matrisen
	inline Matrix3x3 &operator()(int i, int j)
	{
		if(i < 0 || j < 0 || r <= i || c <= j) error("Feil i SMatrise::operator()\n");
		if(row[i] == NULL)
		{
			Node *nyNode = Node::GetNode(i, j, 0);
			SettInn(nyNode);
			return nyNode->data;
		}
		
		Node *p = row[i];
		while(p != NULL)
		{
			if(p->c == j) return p->data;
			p = p->neste;
		}
		Node *nyNode = Node::GetNode(i, j, 0);
		SettInn(nyNode);
		return nyNode->data;
	}


	inline void SlettNull()
	{
		/*
		// Gr igjennom alle noder og sletter dem som er lik null
		for(int i = 0; i < r; i++)
		{
			Node *p = row[i], *forrige = NULL;
			while(p != NULL)
			{
				if(Equals(p->data, 0))
				{
					if(forrige == NULL)
					{
						row[i] = p->neste;
					
					}
					else
					{
						forrige->neste = p->neste;
					
					}
					p = p->neste;
					delete p;
				}
				else
				{
					forrige = p;
					p = p->neste;
				}
			}
		}*/
	}


	inline void NullStill()
	{
		for(int i = 0; i < r; i++)
		{
			//printf("Sletter node\n");
			Node::rekursivSlett = true;
			Node *p = row[i];
			while(p != NULL)
			{
				Node *neste = p->neste;
				Node::returnNode(p);
				p = neste;
			}
			row[i] = 0;
		}
		Node::rekursivSlett = false;
	}

	inline void SettInn(Node *ny)
	{
		if(row[ny->r] == NULL)
		{
			row[ny->r] = ny;
		}
		else if(row[ny->r]->c >= ny->c)
		{
			ny->neste = row[ny->r];
			row[ny->r] = ny;
		}
		else
		{
			Node *forrige = row[ny->r], *p = forrige->neste;
			while(p != NULL)
			{
				if(p->c >= ny->c)
				{
					forrige->neste = ny;
					ny->neste = p;
					
					return;
				}
				forrige = p;
				p = p->neste;
			}
			forrige->neste = ny;
		}
	}

	void skriv()
	{
		/*double **data = new double*[r];
		for(int i = 0; i < r; i++)
		{
			data[i] = new double[c];
			for(int j = 0; j < c; j++) data[i][j] = 0;
			Node *p = row[i];
			while(p != NULL)
			{
				data[p->r][p->c] = p->data;
				p = p->neste;
			}
		}

		for(int i = 0; i < r; i++)
		{
			for(int j = 0; j < c; j++)
			{
				printf("%lf\t", data[i][j]);
			}
			printf("\n");
		}*/
	}
	void skrivTilFil(char *filnavn)
	{
		/*double **data = new double*[r];
		for(int i = 0; i < r; i++)
		{
			data[i] = new double[c];
			for(int j = 0; j < c; j++) data[i][j] = 0;
			Node *p = row[i];
			while(p != NULL)
			{
				data[p->r][p->c] = p->data;
				p = p->neste;
			}
		}
		FILE *skriv;
		fopen_s(&skriv, filnavn, "w");
		
		for(int i = 0; i < r; i++)
		{
			for(int j = 0; j < c; j++)
			{
				fprintf(skriv, "%lf\t", data[i][j]);
			}
			fprintf(skriv, "\n");
		}
		fclose(skriv);*/
	}
		
	inline void Endre(int nr, int nc)
	{
		if(row != NULL)
		{
			for(int i = 0; i < r; i++)
			{
				Node *p = row[i];
				while(p != NULL)
				{
					Node::returnNode(p);
					p = p->neste;
				}
			}
			if(r != nr)
			{
				delete[] row;
				row = new Node*[nr];
			}
		}
		else
		{
			row = new Node*[nr];
		}
		
		
		r = nr; c = nc;
		
		for(int i = 0; i < nr; i++) row[i] = 0;
		
	}



};

class IMatrise
{
public:
	IMatrise() : l(0), data(0) {}
	IMatrise(int i, double null = 1) : l(i)
	{
		data = new double[i];
		for(int i = 0; i < l; i++) data[i] = null;
	}
	~IMatrise()
	{
		if(data != NULL) delete[] data;
		data = NULL;
	}
	inline void Endre(int n)
	{
		l = n;
		if(data != 0) delete[] data;
		data = new double[l];
		for(int i = 0; i < l; i++) data[i] = 1;
	}
	double *data; int l;
	inline double &operator()(int i)
	{
		if(i < 0 || l <= i) error("Feil i IMatrise::operator()\n");
		return data[i];
	}
	void skriv()
	{
		for(int i = 0; i < l; i++)
		{
			printf("%lf\t", data[i]);
		}
		printf("\n");
	}

};
struct Array
{
public:
	Array() : l(0), data(0) {}
	int l;
	double *data;
	Array(int lengde) : l(lengde)
	{
		data = new double[l];
		for(int i = 0; i < l; i++) data[i] = 0;
	}
	~Array()
	{
		if(data != 0)
		{
			delete[] data;
			data = 0;
		}
	}
	inline void Endre(int n)
	{
		if(l != n)
		{
			l = n;
			if(data != 0) delete[] data;
			data = new double[l];
		}
		for(int i = 0; i < l; i++) data[i] = 0;
	}
	inline void NullStill()
	{
		for(int i = 0; i < l; i++)
		{
			data[i] = 0;
		}
	}
	
	inline double &operator()(int i)
	{
		if(i < 0 || l < i) error("Feil i Array::operator()\n");
		return data[i];
	}
	void skriv()
	{
		for(int i = 0; i < l; i++)
		{
			printf("%lf\t", data[i]);
		}
		printf("\n");
	}
	void skrivTilFil(char *filnavn)
	{
		FILE *skriv;
		fopen_s(&skriv, filnavn, "w");
		for(int i = 0; i < l; i++)
		{
			fprintf(skriv, "%lf\t", data[i]);
		}
		fclose(skriv);
	}

};



inline void mulS(Array &res, SMatrise &m, Array &a)
{
	for(int i = 0; i < m.r; i++)
	{
		Node *p = m.row[i];
		res(i) = 0;
		while(p != NULL)
		{
			//res(i) += p->data * a(p->c);
			p = p->neste;
		}
	}
}

inline void mul(Array &res, SMatrise &m, Array &a)
{
	// Skal multiplisere 3x3 matrisen i m med vektoren i a og legge svaret som vektor i res
	//Node nullNode(0, 0, 0, 0);
	Node *null = Node::GetNode(0, 0, 0, 0);
	for(int i = 0; i < m.r; i++)
	{
		Node *p = m.row[i];
		
		res(3*i) = 0;
		res(3*i+1) = 0;
		res(3*i+2) = 0;
		//printf("Ganger\n");
		while(p != NULL)
		{
			res(3*i    ) += p->data.d[0][0] * a(3*p->c) + p->data.d[0][1] * a(3*p->c+1) + p->data.d[0][2] * a(3*p->c+2);
			res(3*i + 1) += p->data.d[1][0] * a(3*p->c) + p->data.d[1][1] * a(3*p->c+1) + p->data.d[1][2] * a(3*p->c+2);
			res(3*i + 2) += p->data.d[2][0] * a(3*p->c) + p->data.d[2][1] * a(3*p->c+1) + p->data.d[2][2] * a(3*p->c+2);
			p = p->neste;
		}
	}
}
inline void mul(SMatrise &res, SMatrise &m, double d)
{
	res.NullStill();
	Node *temp = Node::GetNode(0, 0, 0, 0), *temp2 = temp;
	for(int i = 0; i < m.r; i++)
	{
		temp = temp2;
		temp->neste = 0;
		Node *p = m.row[i];
		Node *nyNode = 0;
		while(p != NULL)
		{
			nyNode = Node::GetNode(p->r, p->c, 0, 0);
			for(int i = 0; i < 3; i++) for(int j = 0; j < 3; j++) nyNode->data.d[i][j] = p->data.d[i][j] * d;
			temp->neste = nyNode;
			temp = nyNode;
			p = p->neste;
		}
		res.row[i] = temp2->neste;
	}
	temp2->neste = 0;
	Node::returnNode(temp2);
}
inline void mul(SMatrise &res, IMatrise &I, SMatrise &S)
{
	res.NullStill();
	for(int i = 0; i < I.l; i++)
	{
		if(!Equals(I(i), 0))
		{
			Node *p = S.row[i];
			while(p != NULL)
			{
				res(p->r, p->c) = p->data * I(i);
				p = p->neste;
			}
		}
	}
}

inline void mul(Array &res, Array &a, double d)
{
	for(int i = 0; i < a.l; i++)
	{
		res(i) = a(i) * d;
	}
}

inline void mul(double &res, Array &a, Array &b)
{
	res = 0;
	for(int i = 0; i < a.l; i++)
	{
		res += a(i) * b(i);
	}
}
inline void mul(IMatrise &res, IMatrise &a, double d)
{
	for(int i = 0; i < a.l; i++)
	{
		res(i) = a(i) * d;
	}
}

inline void mul(Array &res, IMatrise &m, Array &a)
{
	for(int i = 0; i < m.l; i++)
	{
		res(i) = m(i) * a(i);
	}
}


inline void sum(SMatrise &res, SMatrise &a, SMatrise &b)
{
	res.NullStill();
	Node *temp = Node::GetNode(0, 0, 0, 0), *temp2 = temp;
	for(int i = 0; i < a.r; i++)
	{
		Node *pa = a.row[i];
		Node *pb = b.row[i];
		temp = temp2;
		temp->neste = 0;
		Node *nyNode = 0;
		while(pa != NULL && pb != NULL)
		{
			if(pa->c == pb->c)
			{
				//res(pa->r, pa->c) 
				nyNode = Node::GetNode(pa->r, pa->c, 0, 0);
				for(int i = 0; i < 3; i++) for(int j = 0; j < 3; j++) nyNode->data.d[i][j] = pa->data.d[i][j] + pb->data.d[i][j];
				pa = pa->neste;
				pb = pb->neste;
			}
			else if(pa->c < pb->c)
			{
				nyNode = Node::GetNode(pa->r, pa->c, 0, 0); 
				for(int i = 0; i < 3; i++) for(int j = 0; j < 3; j++) nyNode->data.d[i][j] = pa->data.d[i][j];
				pa = pa->neste;
			}
			else
			{
				nyNode = Node::GetNode(pb->r, pb->c, 0, 0); 
				for(int i = 0; i < 3; i++) for(int j = 0; j < 3; j++) nyNode->data.d[i][j] = pb->data.d[i][j];
				pb = pb->neste;
				
			}
			temp->neste = nyNode;
			temp = nyNode;
		}
		while(pa != NULL)
		{
			nyNode = Node::GetNode(pa->r, pa->c, 0, 0); 
			for(int i = 0; i < 3; i++) for(int j = 0; j < 3; j++) nyNode->data.d[i][j] = pa->data.d[i][j];
			pa = pa->neste;
			temp->neste = nyNode;
			temp = nyNode;
		}
		while(pb != NULL)
		{
			nyNode = Node::GetNode(pb->r, pb->c, 0, 0); 
			for(int i = 0; i < 3; i++) for(int j = 0; j < 3; j++) nyNode->data.d[i][j] = pb->data.d[i][j];
			pb = pb->neste;
			temp->neste = nyNode;
			temp = nyNode;
		}
		res.row[i] = temp2->neste;
	}
	temp2->neste = 0;
	Node::returnNode(temp2);
}

inline void sum(Array &res, Array &a, Array &b)
{
	for(int i = 0; i < a.l; i++)
	{
		res(i) = a(i) + b(i);
	}
}


inline void minus(SMatrise &res, SMatrise &a, SMatrise &b)
{
	res.NullStill();
	Node *temp = Node::GetNode(0, 0, 0, 0), *temp2 = temp;
	for(int i = 0; i < a.r; i++)
	{
		Node *pa = a.row[i];
		Node *pb = b.row[i];
		temp = temp2;
		temp->neste = 0;
		Node *nyNode = 0;
		while(pa != NULL && pb != NULL)
		{
			if(pa->c == pb->c)
			{
				//res(pa->r, pa->c) 
				nyNode = Node::GetNode(pa->r, pa->c, 0, 0);
				for(int i = 0; i < 3; i++) for(int j = 0; j < 3; j++) nyNode->data.d[i][j] = pa->data.d[i][j] - pb->data.d[i][j];
				pa = pa->neste;
				pb = pb->neste;
			}
			else if(pa->c < pb->c)
			{
				nyNode = Node::GetNode(pa->r, pa->c, 0, 0); 
				for(int i = 0; i < 3; i++) for(int j = 0; j < 3; j++) nyNode->data.d[i][j] = pa->data.d[i][j];
				pa = pa->neste;
			}
			else
			{
				nyNode = Node::GetNode(pb->r, pb->c, 0, 0); 
				for(int i = 0; i < 3; i++) for(int j = 0; j < 3; j++) nyNode->data.d[i][j] = -pb->data.d[i][j];
				pb = pb->neste;
				
			}
			temp->neste = nyNode;
			temp = nyNode;
		}
		while(pa != NULL)
		{
			nyNode = Node::GetNode(pa->r, pa->c, 0, 0); 
			for(int i = 0; i < 3; i++) for(int j = 0; j < 3; j++) nyNode->data.d[i][j] = pa->data.d[i][j];
			pa = pa->neste;
			temp->neste = nyNode;
			temp = nyNode;
		}
		while(pb != NULL)
		{
			nyNode = Node::GetNode(pb->r, pb->c, 0, 0); 
			for(int i = 0; i < 3; i++) for(int j = 0; j < 3; j++) nyNode->data.d[i][j] = -pb->data.d[i][j];
			pb = pb->neste;
			temp->neste = nyNode;
			temp = nyNode;
		}
		
		res.row[i] = temp2->neste;
	}
	temp2->neste = 0;
	Node::returnNode(temp2);
}

inline void minus(Array &res, Array &a, Array &b)
{
	for(int i = 0; i < a.l; i++)
	{
		res(i) = a(i) - b(i);
	}
}