#pragma once
#define SIGMA 0.000001f
#define ER_LIK(a, b) (a-SIGMA <= b && b <= a+SIGMA)

class vek3
{
public:
	inline vek3(){d[0]=d[1]=d[2]=0;}
	inline vek3(float, float, float);
	inline vek3(vek3 a, vek3 b);
	inline vek3(vek3 &gml);
	inline vek3(vek3 *gml);
	inline ~vek3(void);

	float d[3];

	inline vek3 Cross(vek3 v);
	inline bool operator==(const vek3 &v);
	inline vek3 operator-(const vek3 &v)
	{
		vek3 retur;
		retur.d[0] = d[0]-v.d[0];
		retur.d[1] = d[1]-v.d[1];
		retur.d[2] = d[2]-v.d[2];
		return retur;
	}
	inline double operator*(const vek3 &v)
	{
		return d[0]*v.d[0] + d[1]*v.d[1] + d[2]*v.d[2];
	}
	inline vek3 operator*(const double val)
	{
		return vek3((float)(val*d[0]), (float)(val*d[1]), (float)(val*d[2]));
	}


};
vek3 vek3::Cross(vek3 v)
{
	return vek3(d[1]*v.d[2]-d[2]*v.d[1], d[2]*v.d[0]-d[0]*v.d[2], d[0]*v.d[1]-d[1]*v.d[0]);

}

bool vek3::operator==(const vek3 &v)
{

	return (ER_LIK(d[0], v.d[0]) && ER_LIK(d[1], v.d[1]) && ER_LIK(d[2], v.d[2]));
	
}
vek3::vek3(float a, float b, float c)
{
	d[0] = a; d[1] = b; d[2] = c;
}

vek3::vek3(vek3 a, vek3 b)
{
	d[0] = b.d[0] - a.d[0];
	d[1] = b.d[1] - a.d[1];
	d[2] = b.d[2] - a.d[2];

}
vek3::vek3(vek3 &gml)
{
	d[0] = gml.d[0];
	d[1] = gml.d[1];
	d[2] = gml.d[2];
}
vek3::vek3(vek3 *gml)
{
	d[0] = gml->d[0];
	d[1] = gml->d[1];
	d[2] = gml->d[2];
}
vek3::~vek3(void)
{
}
typedef vek3 Point3D;
typedef vek3 Vektor3D;