#pragma once

#include <cg\cg.h>														// NEW: Cg Header
#include <cg\cggl.h>
#include <stdio.h>

class CGStruct
{
public: // Variable
	CGparameter *fraPar, *verPar;
	int verAntPar, fraAntPar;
private: // Variable
	CGcontext	cgContext;													// A Context To Hold Our Cg Program(s)
	CGprogram	cgFragmentProgram;													// Our Cg Vertex Program
	CGprogram	cgVertexProgram;
	CGprofile	cgVertexProfile;											// The Profile To Use For Our Vertex Shader
	CGprofile	cgFragmentProfile;
public: // Constructor
	CGStruct(char *verProg, char *fraProg,							// Hvilke filer skal lastes inn
			 char **verParNavn, int verAntPar,	// Parameterliste for binding for vertex-programmet
			 char **fraParNavn, int fraAntPar,	// Parameterliste for binding for fragment-programmet
			 char *vertexMain = "main", char *fragmentMain = "main"	// Hva heter main-funksjonene
			 );

public: // Functions
	static int kall_loadVertex, kall_loadFragment;
	void Error(char *sz);

	inline void loadVertex()
	{
		kall_loadVertex++;
		cgGLEnableProfile(cgVertexProfile);
		cgGLBindProgram(cgVertexProgram);
	}
	inline void unloadVertex()
	{
		kall_loadVertex--;
		cgGLDisableProfile(cgVertexProfile);
	}
	
	inline void loadBoth()
	{
		kall_loadVertex++; kall_loadFragment++;
		loadVertex();
		loadFragment();
	}
	inline void unloadBoth()
	{
		kall_loadVertex--; kall_loadFragment--;
		unloadVertex();
		unloadFragment();
	}
	
	inline void loadFragment()
	{
		kall_loadFragment++;
		cgGLBindProgram(cgFragmentProgram);
		cgGLEnableProfile(cgFragmentProfile);
	}
	inline void unloadFragment()
	{
		kall_loadFragment--;
		cgGLDisableProfile(cgFragmentProfile);
	}
};








