#pragma once
#include "Texture.h"
#include <gl/glew.h>
#include <cg\cggl.h>
struct DrawArea
{
	int x, y, w, h;
};
class Draw
{
protected:
	Draw(GLuint f, GLuint b)
	{
		
	}
	Draw()
	{
	}

	void init()
	{
		printf("Oppretter Draw\n");
		glBindFramebufferEXT(GL_FRAMEBUFFER_EXT, m_fb);
		glFramebufferTexture2DEXT(GL_FRAMEBUFFER_EXT,m_buf,GL_TEXTURE_RECTANGLE_NV,m_t->getTID(),0);
	}
public:
	
	virtual inline void EnableDraw()
	{
		glBindFramebufferEXT(GL_FRAMEBUFFER_EXT, m_fb);
		//glFramebufferTexture2DEXT(GL_FRAMEBUFFER_EXT,m_buf,GL_TEXTURE_RECTANGLE_NV,m_t->getTID(),0);
		glDrawBuffer(m_buf);
		//glViewport(da.x, da.y, da.w, da.h);
	}

	virtual inline DrawArea &EnableRead(GLuint tex, CGparameter &cg)
	{
		m_t->BindTexture(tex, cg);
		return da;
	}

	// tex = GL_TEXTURE<X>_ARB
	// cg = cg-parameter for teksturen
	// texCoord = cg-parameter for size-structen
	virtual inline DrawArea &EnableRead(GLuint tex, CGparameter &cg, CGparameter &texCoord)
	{
		m_t->BindTexture(tex, cg);
		// Sender med strrelsen p teksturen(for bruk ved pos = tex * size) og offsetet til dette drawbufferet(x, y)
		cgGLSetParameter4f(texCoord, (GLfloat)m_t->getWidth(), (GLfloat)m_t->getHeight(), (GLfloat)da.x, (GLfloat)da.y);
		return da;
	}
	virtual inline void EnableRead(GLuint tex0, GLuint tex1, GLuint tex2, CGparameter &tc0, CGparameter &tc1, CGparameter &tc2)
	{
		// Gjr ingenting her
		printf("prvde  binde 3 teksturer som 1 i EnableRead\n");
		while(true);
	}

	virtual inline void ReadPixels(int x, int y, int width, int height, GLuint format, GLuint type, GLfloat *pixels)
	{
		glBindFramebufferEXT(GL_FRAMEBUFFER_EXT, m_fb);
		glReadBuffer(m_buf);
		glReadPixels(da.x+x, da.y+y, width, height, format, type, pixels);
	}


public:
	DrawArea da;
	Texture *m_t;
	GLuint m_fb, m_buf;
};

// Klasse for  skrive ut en vektor per piksel
class DrawObject : public Draw
{
public:

	DrawObject(Texture *mt, GLuint f, GLuint b)
	{
		da.w = mt->getWidth();
		da.h = mt->getHeight();
		da.x = da.y = 0;
		

		m_t = mt;
		m_fb = f;
		m_buf = b;
		

		init();
	}
public:

	virtual ~DrawObject(void)
	{
	}
	
	
};

// Klasse for tegning til 3 teksturer for  skrive 3x3 matriser per piksel
class MatrixDrawObject : public Draw
{
public:
	MatrixDrawObject(Texture *t0, Texture *t1, Texture *t2, GLuint f, GLuint b0, GLuint b1, GLuint b2)
	{
		m_fb = f;
		buffers[0] = b0; buffers[1] = b1; buffers[2] = b2;
		tex[0] = t0; tex[1] = t1; tex[2] = t2;
		glBindFramebufferEXT(GL_FRAMEBUFFER_EXT, m_fb);
		glFramebufferTexture2DEXT(GL_FRAMEBUFFER_EXT,buffers[0],GL_TEXTURE_RECTANGLE_NV,tex[0]->getTID(),0);
		glFramebufferTexture2DEXT(GL_FRAMEBUFFER_EXT,buffers[1],GL_TEXTURE_RECTANGLE_NV,tex[1]->getTID(),0);
		glFramebufferTexture2DEXT(GL_FRAMEBUFFER_EXT,buffers[2],GL_TEXTURE_RECTANGLE_NV,tex[2]->getTID(),0);
		

	}
	virtual inline void EnableDraw()
	{
		glBindFramebufferEXT(GL_FRAMEBUFFER_EXT, m_fb);
		glDrawBuffers(3, buffers);
	}
	virtual inline DrawArea &EnableRead(GLuint tex, CGparameter &cg)
	{
		printf("Prvde  binde 3 teksturer som 1 i EnableRead\n");
		while(true);
		return da;
	}
	
	virtual inline void EnableRead(GLuint tex0, GLuint tex1, GLuint tex2, CGparameter &tc0, CGparameter &tc1, CGparameter &tc2)
	{
		tex[0]->BindTexture(tex0, tc0);
		tex[1]->BindTexture(tex1, tc1);
		tex[2]->BindTexture(tex2, tc2);
	}
	Texture *tex[3];
	GLuint buffers[3];
};

// test-klasse for skriving til forskjellige koordinater i en stor tesktur
class DrawObjectAtlas : public Draw
{
public:
	DrawObjectAtlas(Draw *a, int xx, int yy, int ww, int hh)
	{
		printf("Heisann\n");
		da.w = ww;
		da.h = hh;
		da.x = xx+a->da.x;
		da.y = yy+a->da.y;

		m_t = a->m_t;
		m_buf = a->m_buf;
		m_fb = a->m_fb;
	}
public:
	virtual ~DrawObjectAtlas()
	{
	}
};

// Test-klasse for skriving ved  endre teksturen som er attatched til et framebuffer-objekt
class DrawObjectOne : public Draw
{
public:
	enum PRESET_SIZE { SINGLE, MULTIPLE };
	Texture *m_t[3];
	PRESET_SIZE m_s;
	static GLuint m_fb, m_buf[3];
	DrawObjectOne(Texture *tex)
	{
		m_s = SINGLE;
		m_t[0] = tex;
	}
	DrawObjectOne(Texture *t1, Texture *t2, Texture *t3)
	{
		m_t[0] = t1;
		m_t[1] = t2;
		m_t[2] = t3;

		m_s = MULTIPLE;
	}

	static void initPRESET(PRESET_SIZE s)
	{
		glBindFramebufferEXT(GL_FRAMEBUFFER_EXT, m_fb);
		switch(s)
		{
			case SINGLE:
				glDrawBuffer(m_buf[0]);
				break;
			case MULTIPLE:
				glDrawBuffers(3, m_buf);
				break;
			default:
				break;
		}
	}
	void EnableDraw()
	{
		//printf("Kjrer EnableDraw i DrawObjectOne\n");
		switch(m_s)
		{
			case SINGLE:
				glFramebufferTexture2DEXT(GL_FRAMEBUFFER_EXT,m_buf[0],GL_TEXTURE_RECTANGLE_NV,m_t[0]->getTID(),0);
				break;
			case MULTIPLE:
				glFramebufferTexture2DEXT(GL_FRAMEBUFFER_EXT,m_buf[0],GL_TEXTURE_RECTANGLE_NV,m_t[0]->getTID(),0);
				glFramebufferTexture2DEXT(GL_FRAMEBUFFER_EXT,m_buf[1],GL_TEXTURE_RECTANGLE_NV,m_t[1]->getTID(),0);
				glFramebufferTexture2DEXT(GL_FRAMEBUFFER_EXT,m_buf[2],GL_TEXTURE_RECTANGLE_NV,m_t[2]->getTID(),0);
				break;
			default:
				break;
		}
	}
	
};


