#include "Texture.h"
GLuint *Texture::TID = new GLuint[100];
GLuint Texture::n_TID = 0;
GLuint Texture::n_max_TID = 100;

void Texture::initTextureClass()
{
	glGenTextures(n_max_TID, TID);
}

void Texture::extend()
{
	GLuint *ny = new GLuint[n_max_TID*2];
	for(unsigned int i = 0; i < n_max_TID; i++)
	{
		ny[i] = TID[i];
	}
	glGenTextures(n_max_TID, TID);
	for(unsigned int i = 0; i < n_max_TID; i++)
	{
		ny[i+n_max_TID] = TID[i];
	}
	delete[] TID;
	TID = ny;
	n_max_TID *= 2;

}
GLuint Texture::getNextID()
{
	if(n_TID == n_max_TID)
	{
		extend();
	}
	return TID[n_TID++];
}

Texture::Texture(char *filnavn, GLuint type)
{
	BMPClass BMPbilde;
	m_nType = type;
	BMPError err = BMPLoad(filnavn, BMPbilde);
	printf("Lastet inn et bilde p %dx%d piksler\n", BMPbilde.width, BMPbilde.height);
	if(err != NULL)
	{
		TranslateBMPError(err);
		
		m_nID = -1;
	}
	else
	{
		m_nID = getNextID();
		m_nWidth = (int)BMPbilde.width;
		m_nHeight = (int)BMPbilde.height;
		m_pData = (GLfloat*)BMPbilde.bytes;

		BMPbilde.bytes = 0;
		init();
	}
	

}
Texture::Texture(GLuint type, int w, int h)
{
	m_pData = 0;
	m_nWidth = w;
	m_nHeight = h;
	m_nID = getNextID();
	m_nType = type;
	init();
}
Texture::Texture(GLuint type, void *data, int w, int h)
{
	m_nType = type;
	m_pData = (GLfloat*)data;
	m_nWidth = w;
	m_nHeight = h;
	m_nID = getNextID();
	init();
}
void Texture::init()
{
	printf("Binder en tekstur som er %dx%d\n", m_nWidth, m_nHeight);
	switch(m_nType)
	{
	case RGB:
		printf("Binder en RGB-tekstur\n");
		glBindTexture(GL_TEXTURE_2D, m_nID);
		glTexImage2D(GL_TEXTURE_2D, 0, 3, m_nWidth, m_nHeight, 0, GL_RGB, GL_UNSIGNED_BYTE, m_pData);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);// Linear Filtering
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);// Linear Filtering
		break;
	case FLOAT:
		printf("Binder en FLOAT-tekstur\n");
		glBindTexture(GL_TEXTURE_RECTANGLE_NV, m_nID);
		
		glTexImage2D(GL_TEXTURE_RECTANGLE_NV, 0, GL_FLOAT_RGBA32_NV, m_nWidth, m_nHeight, 0, GL_BGRA_EXT, GL_FLOAT, m_pData);
		glTexParameteri(GL_TEXTURE_RECTANGLE_NV, GL_TEXTURE_MAG_FILTER, GL_NEAREST);// Sjekk om begge to skal ha GL_NEAREST
		glTexParameteri(GL_TEXTURE_RECTANGLE_NV, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
		break;
	default:
		break;
	}
}
Texture::~Texture(void)
{
}

GLuint Texture::getTID()
{
	return m_nID;
}