#pragma once
#include "BMPLoader.h"
#include <gl/glew.h>
#include <cg/cggl.h>
#include <cg/cg.h>

class Texture
{
public: // Variables
		enum  { FLOAT, RGB };
private: // Variables
	GLuint m_nID;
	GLuint m_nType;
	int m_nWidth, m_nHeight;
	GLfloat *m_pData;

public: // Constructors
	Texture(char *filnavn, GLuint type);
	Texture(GLuint type, int w, int h); // Opprettet en tom tekstur, f.eks. som skal skrives til
	Texture(GLuint type, void *data, int w, int h); // Oppretter en tekstur med dataene som sendes med

	~Texture(void);

public: // Functions
	void init();
	void clear()	{ if(m_pData != 0) delete[] m_pData; m_pData = 0; }
	
	GLuint getTID();
	int getWidth() { return m_nWidth; }
	int getHeight() { return m_nHeight; }

	inline void BindTexture()
	{
		switch(m_nType)
		{
			case RGB:
				glBindTexture(GL_TEXTURE_2D, m_nID);
				glEnable(GL_TEXTURE_2D);
				break;
			case FLOAT:
				glBindTexture(GL_TEXTURE_RECTANGLE_NV, m_nID);
				glEnable(GL_TEXTURE_RECTANGLE_NV);
				break;
			default:
				break;
		}
	} // Kobler denne til det som er aktiv tekstur

	inline void BindTexture(int t, CGparameter p = NULL)
	{
		
		glActiveTextureARB(t);
		BindTexture();
		if(p != NULL)
		{
			cgGLSetTextureParameter(p, m_nID);
			cgGLEnableTextureParameter(p);
		}
	} // Kobler denne til den teksturen som er angitt av <t>


private: // Static Variables
	static GLuint *TID;
	static GLuint n_TID, n_max_TID;


public: // Static Methods
	static void initTextureClass();
	static void extend();
	static GLuint getNextID();



	
	
};

